<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: field/hstep_file.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_00a13ab5e3afe633796d5c180ae90994.html">field</a>
  </div>
</div>
<div class="contents">
<h1>hstep_file.c</h1><a href="hstep__file_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment">    Copyright (C) 2008 Stefan Tibus</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00008"></a>00008 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00011"></a>00011 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00012"></a>00012 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00013"></a>00013 <span class="comment">    (at your option) any later version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00016"></a>00016 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00017"></a>00017 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00018"></a>00018 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00019"></a>00019 <span class="comment"></span>
<a name="l00020"></a>00020 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00021"></a>00021 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00022"></a>00022 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00023"></a>00023 <span class="comment">*/</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: hstep_file.c 1000 2008-07-31 16:37:20Z tibus $\n\n&quot;</span>;
<a name="l00026"></a>00026 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="field_8h.html">field.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a><a class="code" href="hstep__file_8c.html#af662e3927bc9870f827123b765d572fe">00030</a> <span class="preprocessor">#define HSTEPCOL 2</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="comment">/*</span>
<a name="l00033"></a>00033 <span class="comment">input file structure:</span>
<a name="l00034"></a>00034 <span class="comment">-----------</span>
<a name="l00035"></a>00035 <span class="comment">n</span>
<a name="l00036"></a>00036 <span class="comment">x_0  y_0</span>
<a name="l00037"></a>00037 <span class="comment">x_1  y_1</span>
<a name="l00038"></a>00038 <span class="comment">x_2  y_2</span>
<a name="l00039"></a>00039 <span class="comment">x_3  y_3</span>
<a name="l00040"></a>00040 <span class="comment">...</span>
<a name="l00041"></a>00041 <span class="comment">x_n  y_n</span>
<a name="l00042"></a>00042 <span class="comment">-----------</span>
<a name="l00043"></a>00043 <span class="comment">*/</span>
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 
<a name="l00046"></a><a class="code" href="hstep__file_8c.html#a567e7efd2748f5b33963b581ed12626c">00046</a> <span class="keywordtype">int</span> <a class="code" href="field_8h.html#a567e7efd2748f5b33963b581ed12626c">read_hstep_file</a>(FILE *fd,PetscReal **indata,<span class="keyword">const</span> <span class="keywordtype">int</span> col)
<a name="l00047"></a>00047 {
<a name="l00048"></a>00048   <span class="keywordtype">int</span>            nrows;
<a name="l00049"></a>00049   PetscReal      *xydata;
<a name="l00050"></a>00050 
<a name="l00051"></a>00051   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00052"></a>00052 
<a name="l00053"></a>00053   <span class="keywordtype">int</span> rank,size;
<a name="l00054"></a>00054   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00055"></a>00055   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00056"></a>00056 
<a name="l00057"></a>00057   <span class="keywordflow">if</span> (col&lt;2) {
<a name="l00058"></a>00058     SETERRQ1(PETSC_ERR_ARG_CORRUPT,<span class="stringliteral">&quot;col=%i &lt; 2!\n&quot;</span>,col);
<a name="l00059"></a>00059   }
<a name="l00060"></a>00060 
<a name="l00061"></a>00061   <span class="comment">/* only the first processor reads the file */</span>
<a name="l00062"></a>00062   <span class="keywordflow">if</span> (!rank) {
<a name="l00063"></a>00063     <span class="keywordtype">char</span> msg[256];
<a name="l00064"></a>00064 
<a name="l00065"></a>00065     <span class="comment">/* get number of lines */</span>
<a name="l00066"></a>00066     fscanf(fd,<span class="stringliteral">&quot;%i\n&quot;</span>,&amp;nrows);
<a name="l00067"></a>00067     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Reading column %i, %i lines\n&quot;</span>,col,nrows);
<a name="l00068"></a>00068 
<a name="l00069"></a>00069     <span class="comment">/* account for additional first and last entry */</span>
<a name="l00070"></a>00070     nrows += 2;
<a name="l00071"></a>00071 
<a name="l00072"></a>00072     ierr = PetscMalloc(<a class="code" href="hstep__file_8c.html#af662e3927bc9870f827123b765d572fe">HSTEPCOL</a>*nrows*<span class="keyword">sizeof</span>(PetscReal),&amp;xydata);CHKERRQ(ierr);
<a name="l00073"></a>00073 
<a name="l00074"></a>00074     <span class="comment">/* get xydata from file (leave room for first ) */</span>
<a name="l00075"></a>00075     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=1; i&lt;nrows-1; i++) {
<a name="l00076"></a>00076       <span class="keywordtype">int</span> k;
<a name="l00077"></a>00077       <span class="comment">/* read x from first column */</span>
<a name="l00078"></a>00078 <span class="preprocessor">#ifdef PETSC_USE_SINGLE</span>
<a name="l00079"></a>00079 <span class="preprocessor"></span>      k=fscanf(fd,<span class="stringliteral">&quot;%f&quot;</span>,xydata+i*<a class="code" href="hstep__file_8c.html#af662e3927bc9870f827123b765d572fe">HSTEPCOL</a>+0);
<a name="l00080"></a>00080 <span class="preprocessor">#else</span>
<a name="l00081"></a>00081 <span class="preprocessor"></span>      k=fscanf(fd,<span class="stringliteral">&quot;%lf&quot;</span>,xydata+i*<a class="code" href="hstep__file_8c.html#af662e3927bc9870f827123b765d572fe">HSTEPCOL</a>+0);
<a name="l00082"></a>00082 <span class="preprocessor">#endif</span>
<a name="l00083"></a>00083 <span class="preprocessor"></span>      <span class="keywordflow">if</span> (k!=1) {
<a name="l00084"></a>00084         SETERRQ2(PETSC_ERR_FILE_UNEXPECTED,
<a name="l00085"></a>00085           <span class="stringliteral">&quot;xydata in corrupt in row %i col %i\n&quot;</span>,
<a name="l00086"></a>00086           i,1
<a name="l00087"></a>00087         );
<a name="l00088"></a>00088       }
<a name="l00089"></a>00089 
<a name="l00090"></a>00090       <span class="comment">/* read y from column col */</span>
<a name="l00091"></a>00091       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=1; j&lt;col; j++) {
<a name="l00092"></a>00092 <span class="preprocessor">#ifdef PETSC_USE_SINGLE</span>
<a name="l00093"></a>00093 <span class="preprocessor"></span>        k=fscanf(fd,<span class="stringliteral">&quot;%f&quot;</span>,xydata+i*<a class="code" href="hstep__file_8c.html#af662e3927bc9870f827123b765d572fe">HSTEPCOL</a>+1);
<a name="l00094"></a>00094 <span class="preprocessor">#else</span>
<a name="l00095"></a>00095 <span class="preprocessor"></span>        k=fscanf(fd,<span class="stringliteral">&quot;%lf&quot;</span>,xydata+i*<a class="code" href="hstep__file_8c.html#af662e3927bc9870f827123b765d572fe">HSTEPCOL</a>+1);
<a name="l00096"></a>00096 <span class="preprocessor">#endif</span>
<a name="l00097"></a>00097 <span class="preprocessor"></span>
<a name="l00098"></a>00098         <span class="keywordflow">if</span> (k!=1) {
<a name="l00099"></a>00099           SETERRQ2(PETSC_ERR_FILE_UNEXPECTED,
<a name="l00100"></a>00100             <span class="stringliteral">&quot;xydata in corrupt in row %i col %i\n&quot;</span>,
<a name="l00101"></a>00101             i,j
<a name="l00102"></a>00102           );
<a name="l00103"></a>00103         }
<a name="l00104"></a>00104       }
<a name="l00105"></a>00105       <span class="comment">/* read remainder of this line */</span>
<a name="l00106"></a>00106       fgets(msg,256,fd);
<a name="l00107"></a>00107     }
<a name="l00108"></a>00108 
<a name="l00109"></a>00109     <span class="comment">/* set first xydata set */</span>
<a name="l00110"></a>00110     xydata[0]=PETSC_MIN;
<a name="l00111"></a>00111     xydata[1]=0.0;
<a name="l00112"></a>00112 
<a name="l00113"></a>00113     <span class="comment">/* set last xydata set */</span>
<a name="l00114"></a>00114     xydata[<a class="code" href="hstep__file_8c.html#af662e3927bc9870f827123b765d572fe">HSTEPCOL</a>*(nrows-1)+0]=PETSC_MAX;
<a name="l00115"></a>00115     xydata[<a class="code" href="hstep__file_8c.html#af662e3927bc9870f827123b765d572fe">HSTEPCOL</a>*(nrows-1)+1]=0.0;
<a name="l00116"></a>00116 
<a name="l00117"></a>00117     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00118"></a>00118       <span class="stringliteral">&quot;%14s %14s\n&quot;</span>,
<a name="l00119"></a>00119       <span class="stringliteral">&quot;step&quot;</span>,<span class="stringliteral">&quot;scale&quot;</span>
<a name="l00120"></a>00120     );
<a name="l00121"></a>00121 
<a name="l00122"></a>00122     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;nrows; i++) {
<a name="l00123"></a>00123       PetscPrintf(PETSC_COMM_WORLD,
<a name="l00124"></a>00124         <span class="stringliteral">&quot;%14e %14e\n&quot;</span>,
<a name="l00125"></a>00125         xydata[<a class="code" href="hstep__file_8c.html#af662e3927bc9870f827123b765d572fe">HSTEPCOL</a>*i+0],
<a name="l00126"></a>00126         xydata[<a class="code" href="hstep__file_8c.html#af662e3927bc9870f827123b765d572fe">HSTEPCOL</a>*i+1]
<a name="l00127"></a>00127       );
<a name="l00128"></a>00128     }
<a name="l00129"></a>00129   }
<a name="l00130"></a>00130 
<a name="l00131"></a>00131   <span class="comment">/* broadcast xydata to all processors */</span>
<a name="l00132"></a>00132   ierr = MPI_Bcast(&amp;nrows,1,MPI_INT,0,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00133"></a>00133   <span class="keywordflow">if</span> (rank) {
<a name="l00134"></a>00134     ierr = PetscMalloc(<a class="code" href="hstep__file_8c.html#af662e3927bc9870f827123b765d572fe">HSTEPCOL</a>*nrows*<span class="keyword">sizeof</span>(PetscReal),&amp;xydata);CHKERRQ(ierr);
<a name="l00135"></a>00135   }
<a name="l00136"></a>00136   ierr = MPI_Bcast(xydata,nrows*<a class="code" href="hstep__file_8c.html#af662e3927bc9870f827123b765d572fe">HSTEPCOL</a>,MPIU_SCALAR,0,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00137"></a>00137   *indata=xydata;
<a name="l00138"></a>00138 
<a name="l00139"></a>00139   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00140"></a>00140 }
<a name="l00141"></a>00141 
<a name="l00142"></a><a class="code" href="hstep__file_8c.html#a17eff24cb6814658a628e43ce697f54a">00142</a> PetscReal <a class="code" href="field_8h.html#aeebb8d32f6d9e3ab71e50c03e1372717">get_scalf_hstep</a>(PetscReal xydata[],PetscReal xval)
<a name="l00143"></a>00143 {
<a name="l00144"></a>00144   <span class="keywordtype">int</span>       tint;
<a name="l00145"></a>00145   PetscReal result;
<a name="l00146"></a>00146 
<a name="l00147"></a>00147   tint=0;
<a name="l00148"></a>00148   <span class="keywordflow">while</span> (xval &gt; xydata[<a class="code" href="hstep__file_8c.html#af662e3927bc9870f827123b765d572fe">HSTEPCOL</a>*(tint+1)]) tint++;
<a name="l00149"></a>00149 
<a name="l00150"></a>00150   <span class="comment">/* calculate scaling factor */</span>
<a name="l00151"></a>00151   result=xydata[<a class="code" href="hstep__file_8c.html#af662e3927bc9870f827123b765d572fe">HSTEPCOL</a>*tint+1];
<a name="l00152"></a>00152 
<a name="l00153"></a>00153   <span class="keywordflow">return</span>(result);
<a name="l00154"></a>00154 }
<a name="l00155"></a>00155 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

